package com.inca.npbusi.sales.bms_tr_fetch;

import com.inca.entity.base.Goods;
import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.entity.client.pub.LotOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_lot_def_hov.Bms_lot_def_hov;

public class Bms_tr_fetch_detail extends CDetailModel {
   public Bms_tr_fetch_detail(CFrame var1, CMdeModel var2) {
      super(var1, "收货通知细单表 ", var2);
      this.getDBColumnDisplayInfo("canfetqty").setDbcolumn(false);
   }

   public String getTablename() {
      return "bms_tr_fetch_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "usestatus", "1");
      return super.on_new(var1);
   }

   public String getHovOtherWheres(int var1, String var2) {
      if (var2.equals("lotno")) {
         if ((var2 = this.getItemValue(var1, "goodsid")) != null && var2.length() != 0) {
            return " goodsid=" + var2;
         } else {
            this.infoMessage("提示", "请先选择货品！");
            return "1>2";
         }
      } else if (var2.equalsIgnoreCase("opcode")) {
         var2 = this.a();
         return "nvl(accflag,0)<>5 " + var2;
      } else if (var2.equals("priceopcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "companyid");
         String var3;
         if ((var3 = this.getItemValue(var1, "goodsid")) != null && !"".equals(var3)) {
            return "(customid is null or customid = " + var2 + ") and goodsid = " + var3 + " and priceid IN(SELECT priceid FROM pub_price_type WHERE workflag IN(1)) " + "and entryid=" + ((Bms_tr_fetch_mde)this.mdemodel).getEntryid();
         } else {
            this.infoMessage("提示", "没有选择货品,请通过货品操作码hov回填,否则查不到数据");
            return "1=2";
         }
      } else {
         return super.getHovOtherWheres(var1, var2);
      }
   }

   private String a() {
      int var1 = this.mdemodel.getMasterModel().getRow();
      String var2 = ((Bms_tr_fetch_mde)this.mdemodel).getEntryid();
      String var5 = this.mdemodel.getMasterModel().getItemValue(var1, "companyid");
      CompanyOnClient var6;
      (var6 = new CompanyOnClient(var5)).setCompanyType(2);
      String var3 = " and " + GSPHelper.getGoodsOtherWheresOnHov(var2, "pub_goods_dtl_hov_v", "goodsid", true, false);

      try {
         var3 = var3 + var6.sendLimitCheck("4", var2);
         return var3;
      } catch (Exception var4) {
         this.errorMessage("获取供应商经营范围、类别时错误", var4.getMessage());
         return "";
      }
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3 = "";

      try {
         var3 = NpbusiDBHelper.getSysParaConfig(ClientUserManager.getCurrentUser().getEntryid(), "sabackticksource");
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      String var4;
      if (var3.equals("1") && ((var4 = this.getItemValue(var1, "saledtlid")).equals("") || var4 == null)) {
         this.infoMessage("提示!", "销退申请必须选原单!");
         return -1;
      } else if (DecimalHelper.toDec(this.getItemValue(var1, "goodsqty")).compareTo(DecimalHelper.toDec("0")) <= 0) {
         this.infoMessage("提示!", " 数量必须大于零!");
         return -1;
      } else {
         var3 = this.getItemValue(var1, "batchflag");
         if (!"1".equals(var3) || (var3 = this.getItemValue(var1, "batchprice")) != null && !"".equals(var3)) {
            return super.on_checkrow(var1, var2);
         } else {
            this.infoMessage("提示", "要求制定批次价，含税批次价必填！");
            return -1;
         }
      }
   }

   protected int on_beforedel(int var1) {
      String var2;
      if ((var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "wfusestatus")) == null) {
         var2 = "";
      }

      if (!var2.equals("1") && !var2.equals("2")) {
         return super.on_beforedel(var1);
      } else {
         this.infoMessage("提示", "送审或审批完成，不能删除!");
         return -1;
      }
   }

   protected int on_beforemodify(int var1) {
      if (!this.getItemValue(var1, "usestatus").equals("1")) {
         return -1;
      } else {
         String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "wfusestatus");
         return !"".equals(var2) && !"0".equals(var2) && !"3".equals(var2) ? -1 : super.on_beforemodify(var1);
      }
   }

   public void gensabackdtl(int[] var1, DBTableModel var2) {
      DBTableModel var3 = this.getDBtableModel();
      int var4 = var1.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         int var6 = var3.getRowCount();
         var3.appendRow();
         RemotesqlHelper var7 = new RemotesqlHelper();
         String var8 = "select proddate,invaliddate,killlotno,killdate,approvedocno,checkno        from bms_lot_def where lotid = " + var2.getItemValue(var1[var5], "lotid");
         Object var9 = null;

         try {
            if (var7.doSelect(var8, 0, 1).getRowCount() > 0) {
               var3.setItemValue(var6, "proddate", var2.getItemValue(var1[var5], "proddate"));
               var3.setItemValue(var6, "lotinvaliddate", var2.getItemValue(var1[var5], "invaliddate"));
               var3.setItemValue(var6, "killlotno", var2.getItemValue(var1[var5], "killlotno"));
               var3.setItemValue(var6, "killdate", var2.getItemValue(var1[var5], "killdate"));
               var3.setItemValue(var6, "approvedocno", var2.getItemValue(var1[var5], "approvedocno"));
               var3.setItemValue(var6, "checkno", var2.getItemValue(var1[var5], "checkno"));
            }
         } catch (Exception var10) {
            var10.printStackTrace();
         }

         var3.setItemValue(var6, "opcode", var2.getItemValue(var1[var5], "opcode"));
         var3.setItemValue(var6, "goodsno", var2.getItemValue(var1[var5], "goodsno"));
         var3.setItemValue(var6, "goodsname", var2.getItemValue(var1[var5], "goodsname"));
         var3.setItemValue(var6, "currencyname", var2.getItemValue(var1[var5], "currencyname"));
         var3.setItemValue(var6, "goodsunit", var2.getItemValue(var1[var5], "goodsunit"));
         var3.setItemValue(var6, "goodstype", var2.getItemValue(var1[var5], "goodstype"));
         var3.setItemValue(var6, "prodarea", var2.getItemValue(var1[var5], "prodarea"));
         var3.setItemValue(var6, "factoryname", var2.getItemValue(var1[var5], "factoryname"));
         var3.setItemValue(var6, "packname", var2.getItemValue(var1[var5], "packname"));
         var3.setItemValue(var6, "packsize", var2.getItemValue(var1[var5], "packsize"));
         var3.setItemValue(var6, "goodsqty1", var2.getItemValue(var1[var5], "goodsqty"));
         var3.setItemValue(var6, "usestatus", "1");
         var3.setItemValue(var6, "batchno", var2.getItemValue(var1[var5], "batchno"));
         var3.setItemValue(var6, "lotno", var2.getItemValue(var1[var5], "lotno"));
         var3.setItemValue(var6, "goodsstatusid", var2.getItemValue(var1[var5], "goodsstatusid"));
         var3.setItemValue(var6, "dtlmemo", var2.getItemValue(var1[var5], "dtlmemo"));
         var3.setItemValue(var6, "goodsid", var2.getItemValue(var1[var5], "goodsid"));
         var3.setItemValue(var6, "factoryid", var2.getItemValue(var1[var5], "factoryid"));
         var3.setItemValue(var6, "goodsdtlid", var2.getItemValue(var1[var5], "goodsdtlid"));
         var3.setItemValue(var6, "batchid", var2.getItemValue(var1[var5], "batchid"));
         var3.setItemValue(var6, "lotid", var2.getItemValue(var1[var5], "lotid"));
         var3.setItemValue(var6, "saledtlid", var2.getItemValue(var1[var5], "salesdtlid"));
         var3.setItemValue(var6, "iodtlid", var2.getItemValue(var1[var5], "iodtlid"));
         var3.setItemValue(var6, "priceid", var2.getItemValue(var1[var5], "priceid"));
         var3.setItemValue(var6, "priceopcode", var2.getItemValue(var1[var5], "priceopcode"));
         var3.setItemValue(var6, "pricename", var2.getItemValue(var1[var5], "pricename"));
         var3.setItemValue(var6, "unitprice", var2.getItemValue(var1[var5], "unitprice"));
         var3.setItemValue(var6, "timepriceid", var2.getItemValue(var1[var5], "timepriceid"));
         var3.setItemValue(var6, "timeprice", var2.getItemValue(var1[var5], "timeprice"));
         var3.setItemValue(var6, "timepricename", var2.getItemValue(var1[var5], "timepricename"));
         var3.setItemValue(var6, "oldcredate", var2.getItemValue(var1[var5], "credate"));
         String var11 = DecimalHelper.sub(var2.getItemValue(var1[var5], "goodsqty"), var2.getItemValue(var1[var5], "backQty"), 6);
         var3.setItemValue(var6, "canfetqty", var11);
         var3.setItemValue(var6, "goodsqty", var11);
      }

      this.tableChanged();
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4;
      String var6;
      if ("lotno".equals(var2)) {
         var4 = this.getItemValue(var1, "goodsid");
         if (var3 == null || "".equals(var3) || var3.length() == 0) {
            this.setItemValue(var1, "lotid", "");
            this.setItemValue(var1, "proddate", "");
            this.setItemValue(var1, "lotinvaliddate", "");
            this.setItemValue(var1, "approvedocno", "");
            this.setItemValue(var1, "killlotno", "");
            this.setItemValue(var1, "killdate", "");
            this.setItemValue(var1, "printset", "");
            this.setItemValue(var1, "checkno", "");
            this.setItemValue(var1, "synchronizedapprovetogoods", "");
            super.on_itemvaluechange(var1, var2, var3);
            return;
         }

         if (var4 == null || "".equals(var4)) {
            this.infoMessage("提示", "请先选择货品");
            this.setItemValue(var1, "lotno", "");
            super.on_itemvaluechange(var1, var2, var3);
            return;
         }

         String var5 = this.getBatchNoCount(var3);
         this.setItemValue(var1, "lotid", "");
         this.setItemValue(var1, "proddate", "");
         this.setItemValue(var1, "lotinvaliddate", "");
         this.setItemValue(var1, "approvedocno", "");
         this.setItemValue(var1, "killlotno", "");
         this.setItemValue(var1, "killdate", "");
         this.setItemValue(var1, "printset", "");
         this.setItemValue(var1, "checkno", "");
         this.setItemValue(var1, "synchronizedapprovetogoods", "");
         if ("0".equals(var5)) {
            LotOnClient var14;
            (var14 = new LotOnClient((String)null, var3, var4)).autoGenProdAndInvalidDate();
            this.setItemValue(var1, "proddate", var14.getProdDate());
            this.setItemValue(var1, "lotinvaliddate", var14.getInvalidDate());
            this.setItemValue(var1, "killdate", NpbusiDBHelper.getSysdate());
            this.setItemValue(var1, "lotid", "");
         } else {
            Bms_lot_def_hov var15 = new Bms_lot_def_hov();
            if (var3 != null && !var3.trim().isEmpty()) {
               var6 = " and lotno like '" + var3 + "'";
            } else {
               var6 = " and trim(lotno) is null";
            }

            DBTableModel var13;
            if ((var13 = var15.showDialog(this.frame, "选择批号", "", "", "goodsid = " + var4 + var6)) == null) {
               this.setFocus("lotno");
               return;
            }

            this.setItemValue(var1, "lotno", var13.getItemValue(0, "lotno"));
            this.setItemValue(var1, "lotid", var13.getItemValue(0, "lotid"));
            this.setItemValue(var1, "lotinvaliddate", var13.getItemValue(0, "invaliddate"));
            this.setItemValue(var1, "proddate", var13.getItemValue(0, "proddate"));
            this.setItemValue(var1, "approvedocno", var13.getItemValue(0, "approvedocno"));
            this.setItemValue(var1, "checkno", var13.getItemValue(0, "checkno"));
            this.setItemValue(var1, "killdate", var13.getItemValue(0, "killdate"));
            this.setItemValue(var1, "killlotno", var13.getItemValue(0, "killlotno"));
            this.setItemValue(var1, "printset", var13.getItemValue(0, "printset"));
         }
      }

      if (var2.equals("goodsqty") && !var3.equals("") && (var4 = this.getItemValue(var1, "canfetqty")) != null && !"".equals(var4) && DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec(var4)) > 0) {
         this.setItemValue(var1, var2, "");
         this.infoMessage("提示！", "通知数量不能超过可退数量！");
      } else {
         if (var2.equals("goodsid")) {
            var6 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            String var7 = this.getItemValue(var1, "goodsid");
            DBTableModel var8 = null;
            ClientRequest var9 = new ClientRequest();
            StringCommand var10 = new StringCommand("根据取价逻辑自动提取价格信息");
            ParamCommand var11;
            (var11 = new ParamCommand()).addParam("customid", var6);
            var11.addParam("goodsid", var7);
            var11.addParam("entryid", ((Bms_tr_fetch_mde)this.mdemodel).getEntryid());
            var9.addCommand(var10);
            var9.addCommand(var11);
            ServerResponse var16 = null;

            try {
               var16 = SendHelper.sendRequest(var9);
            } catch (Exception var12) {
               var12.printStackTrace();
            }

            if (((StringCommand)var16.commandAt(0)).getString().startsWith("+OK")) {
               if (var16.commandAt(1) instanceof DataCommand) {
                  var8 = ((DataCommand)var16.commandAt(1)).getDbmodel();
               } else if (var16.commandAt(1) instanceof StringCommand) {
                  var16.commandAt(1);
               }
            }

            if (var8 != null && var8.getRowCount() > 0) {
               var6 = var8.getItemValue(0, "price");
               var7 = var8.getItemValue(0, "priceid");
               this.setItemValue(var1, "priceid", var7);
               this.setItemValue(var1, "priceopcode", var8.getItemValue(0, "priceopcode"));
               this.setItemValue(var1, "pricename", var8.getItemValue(0, "pricename"));
               this.setItemValue(var1, "unitprice", var6);
            }

            this.setItemValue(var1, "lotno", "");
            this.setItemValue(var1, "lotid", "");
         }

         super.on_itemvaluechange(var1, var2, var3);
      }
   }

   protected int on_beforeNew() {
      if (!this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "wfusestatus").equals("")) {
         return -1;
      } else if (!this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus").equals("2")) {
         return -1;
      } else {
         String var1 = "";

         try {
            var1 = NpbusiDBHelper.getSysParaConfig(ClientUserManager.getCurrentUser().getEntryid(), "sabackticksource");
         } catch (Exception var3) {
            var3.printStackTrace();
         }

         if (var1.equals("1")) {
            this.infoMessage("提示!", "销退申请必须选原单!");
            return -1;
         } else if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
            this.infoMessage("提示!", "总单为删除状态不能新增细单!");
            return -1;
         } else {
            return super.on_beforeNew();
         }
      }
   }

   protected String getBatchNoCount(String var1) {
      int var2 = this.mdemodel.getDetailModel().getRow();
      String var6 = this.mdemodel.getDetailModel().getItemValue(var2, "goodsid");
      String var3 = "";
      DBTableModel var4 = null;
      var6 = "select count(1) from bms_lot_def where goodsid=" + var6;
      if (var1 != null && !var1.trim().isEmpty()) {
         var1 = " and lotno like '" + var1 + "'";
      } else {
         var1 = " and trim(lotno) is null";
      }

      var6 = var6 + var1;
      RemotesqlHelper var7 = new RemotesqlHelper();

      try {
         var4 = var7.doSelect(var6, 0, 1);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if (var4 != null && var4.getRowCount() > 0) {
         var3 = var4.getItemValue(0, 0);
      }

      return var3;
   }

   protected String getEditablecolumns(int var1) {
      String var2;
      if ((var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "wfusestatus")) == null) {
         var2 = "";
      }

      if (!var2.equals("")) {
         return "nothing";
      } else if ((var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus")) != null && !var2.equals("2")) {
         return "nothing";
      } else if ((var2 = this.getItemValue(var1, "usestatus")) != null && !var2.equals("1")) {
         return "nothing";
      } else {
         if ((var2 = this.getItemValue(var1, "saledtlid")) == null) {
            var2 = "";
         }

         String var3;
         String var4;
         if ((var3 = this.mdemodel.getDetailModel().getItemValue(var1, "lotid")) != null && !"".equals(var3)) {
            return (var4 = this.getItemValue(var1, "batchid")) != null && !"".equals(var4) ? "lotno,opcode,priceopcode,pricename,unitprice,goodsqty,batchflag,batchprice,dtlmemo" : "lotno,opcode,priceopcode,pricename,unitprice,goodsqty,batchflag,batchprice,dtlmemo,supplyname";
         } else if (!"".equals(var2)) {
            return (var4 = this.getItemValue(var1, "batchid")) != null && !"".equals(var4) ? "priceopcode,unitprice,goodsqty,dtlmemo" : "priceopcode,unitprice,goodsqty,dtlmemo,batchflag,batchprice";
         } else {
            return (var4 = this.getItemValue(var1, "batchid")) != null && !"".equals(var4) ? "opcode,goodsqty,priceopcode,unitprice,lotno,dtlmemo,lotinvaliddate,approvedocno,checkno,killlotno,killdate,synchronizedapprovetogoods" : "opcode,goodsqty,priceopcode,unitprice,lotno,dtlmemo,batchflag,batchprice,proddate,lotinvaliddate,approvedocno,checkno,killlotno,killdate,synchronizedapprovetogoods,supplyname";
         }
      }
   }

   public int on_hov(int var1, String var2, DBTableModel var3) {
      if (var3 != null && var3.getRowCount() != 0) {
         if (var2.equals("opcode")) {
            String var4 = var3.getItemValue(0, "goodsid");
            int var6 = this.mdemodel.getMasterModel().getRow();
            if (!(new CompanyOnClient(this.mdemodel.getMasterModel().getItemValue(var6, "companyid"))).sentLimitCheck("4", ((Bms_tr_fetch_mde)this.mdemodel).getEntryid(), new Goods(var4))) {
               return 0;
            }
         }

         return super.on_hov(var1, var2, var3);
      } else {
         return 0;
      }
   }
}
